
try {

    var zineIsArticleModified = false
    var isEditMode = false
    var zineEditor = new ZineEditor(document.body, { Vue: window.Vue })

    // Create Base64 Object
    var Base64={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){var t="";var n,r,i,s,o,u,a;var f=0;e=Base64._utf8_encode(e);while(f<e.length){n=e.charCodeAt(f++);r=e.charCodeAt(f++);i=e.charCodeAt(f++);s=n>>2;o=(n&3)<<4|r>>4;u=(r&15)<<2|i>>6;a=i&63;if(isNaN(r)){u=a=64}else if(isNaN(i)){a=64}t=t+this._keyStr.charAt(s)+this._keyStr.charAt(o)+this._keyStr.charAt(u)+this._keyStr.charAt(a)}return t},decode:function(e){var t="";var n,r,i;var s,o,u,a;var f=0;e=e.replace(/++[++^A-Za-z0-9+/=]/g,"");while(f<e.length){s=this._keyStr.indexOf(e.charAt(f++));o=this._keyStr.indexOf(e.charAt(f++));u=this._keyStr.indexOf(e.charAt(f++));a=this._keyStr.indexOf(e.charAt(f++));n=s<<2|o>>4;r=(o&15)<<4|u>>2;i=(u&3)<<6|a;t=t+String.fromCharCode(n);if(u!=64){t=t+String.fromCharCode(r)}if(a!=64){t=t+String.fromCharCode(i)}}t=Base64._utf8_decode(t);return t},_utf8_encode:function(e){e=e.replace(/\r\n/g,"n");var t="";for(var n=0;n<e.length;n++){var r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r)}else if(r>127&&r<2048){t+=String.fromCharCode(r>>6|192);t+=String.fromCharCode(r&63|128)}else{t+=String.fromCharCode(r>>12|224);t+=String.fromCharCode(r>>6&63|128);t+=String.fromCharCode(r&63|128)}}return t},_utf8_decode:function(e){var t="";var n=0;var r=c1=c2=0;while(n<e.length){r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r);n++}else if(r>191&&r<224){c2=e.charCodeAt(n+1);t+=String.fromCharCode((r&31)<<6|c2&63);n+=2}else{c2=e.charCodeAt(n+1);c3=e.charCodeAt(n+2);t+=String.fromCharCode((r&15)<<12|(c2&63)<<6|c3&63);n+=3}}return t}}

    // 进行初始化前的组件配置项配置
    try {
        // 禁用题图编辑面板
        zineEditor.gStore.config.components.ZineTitleImage.disableEditPannel = true

        // 禁用图片组件的鼠标hover出现编辑框的特性，否则在iOS上会阻止点击事件导致无法选中
        zineEditor.gStore.config.components.ZinePhoto.disableHoverEdit = true
    } catch (e) {
        console.log(e)
    }

    zineEditor.onUndoRedoStatusChange(function (canUndo, canRedo) {
        if (isEditMode) {
            if (nativeZineEditor != null) {
                nativeZineEditor.onUndoRedoStateChanged(canUndo, canRedo);
            }
        }
    });
    zineEditor.onContentModify(function () {
        if (nativeZineEditor != null) {
            nativeZineEditor.onModify()
        }
        if (isEditMode) {
            zineIsArticleModified = true
        }
    })

    // 键盘弹出时，webview的尺寸会发生变化，进而发生resize事件
    window.addEventListener('resize', function () {
        zineEditor.scrollToCursor()
    })

    zineEditor.onResourceMutation(function (resourceMutation) {
        if (nativeZineEditor != null) {
            var resource = {
                id: resourceMutation.resource.id,
                remoteURL: resourceMutation.resource.remoteURL,
                localURL: resourceMutation.resource.localURL
            }
            nativeZineEditor.onResourceMutation(resourceMutation.property, JSON.stringify(resource))
        }
    })

    zineEditor.onCursorStyleChange(function (style) {
        if (nativeZineEditor != null) {
            nativeZineEditor.onCursorStyleChanged(JSON.stringify(style))
        }
    })

    zineEditor.onClickImg(function (result) {
        var index = result.index
        var list = result.list
        // index为当前点击图片的srcId在list里的位置
        // list为当前文档中所有图片的srcId的顺序列表
        if (nativeZineEditor != null) {
            nativeZineEditor.onClickedImage(index, JSON.stringify(list))
        }
    })

    zineEditor.onExecCommand(function (command, wordInfo, timeout) {
//        console.log(command + "|" + JSON.stringify(wordInfo) + "|" + timeout)
        execCommandOperate(command, wordInfo, timeout)
    })

    function execCommandOperate(command, wordInfo, timeout) {
        try {
            nativeZineEditor.onExecCommand("[js log]" + command, JSON.stringify(wordInfo), timeout)
        } catch (e){

        }
    }

    zineEditor.onError(function (error, vm, info) {
        kernelOnError(info)
     })

    function kernelOnError(info) {
        try {
            nativeZineEditor.onError("[js error]" + "info: " + info)
        } catch (e){

        }
    }

    function getContentSize() {
        var pageEle = document.getElementById('editor')
        return pageEle.offsetHeight;
    }

    function setMode(mode) {
        zineEditor.setMode(mode)
        isEditMode = mode === 'edit'
    }

    function changeParagraph(type, indent) {
        zineEditor.setTextIndent(indent)
        zineEditor.changeParagraph(type)
    }

    function setTextStyle(fontFamily, color) {
        zineEditor.rootElem.focus()
        zineEditor.setFontFamily(fontFamily)
        zineEditor.setFontColor(color)
    }

    function loadHtml(contentObj) {
        var text = contentObj["text"]
        if (text == null) {
            console.log("text not found")
            text = ""
        }
        execCommandOperate("loadHtml", {"total" : text.length} , 0)
        zineEditor.loadHTML(text)
    }

    function getArticle() {
        zineEditor.clearResourceUnlinked()
        var abstractInfo = zineEditor.getAbstract()
        var rawText = abstractInfo.rawText
        var articleBanner = zineEditor.getTitleImage()
        var bannerTitle = ''
        if (articleBanner && articleBanner.title && articleBanner.title.length > 0) {
            rawText = articleBanner.title + '\n' + rawText
        }
        var resourceIds = abstractInfo.resourceIdList

        var result = {
            content:zineEditor.getHTML(),
            wordStatics: zineEditor.getWordCountInfo(),
            rawText: rawText,
            resourceIds: resourceIds
        }
        return JSON.stringify(result)
    }

    function refreshModifiedFlag() {
        var result = zineIsArticleModified
        zineIsArticleModified = false
        return result
    }

    function setWindowInsetTopIfTitleImageExist(value) {
        if (zineEditor.getTitleImage()) {
            zineEditor.setSafeAreaPadding({
                left: '0px',
                top: '0px',
                right: '0px',
                bottom: '0px',
            })
        } else {
            zineEditor.setSafeAreaPadding({
                left: '0px',
                top: value,
                right: '0px',
                bottom: '0px',
            })
        }
    }

    function pasteContents(json) {
        try {
            var text = json['text']
            zineEditor.pasteContents(text)
        } catch (e) {}
    }

    function setTitleImage(param) {
        zineEditor.setTitleImage(param)
     }

    function openDarkMode() {
         document.body.style.background = '#000000'
         zineEditor.openDarkMode()
    }

    function closeDarkMode() {
         document.body.style.background = '#ffffff'
         zineEditor.closeDarkMode()
    }

    function exportContent(type){
        var content = zineEditor.exportContent(type)
        return zineEditor.$util.stabilizeStr(content)
    }

    function enableMarkdown(enable) {
        zineEditor.gStore.config.markdownInput = enable
    }

} catch (e) {
    console.log(e.stack)
}